#include "lscolor.h"

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{

	int code=0, i, r, g, b;
	char rgb[8], clrVal[8];
	bool sysBool;
	DWORD color;
	LOGFONT fontInfo;
	NONCLIENTMETRICS ncMetrics;
   	
	int sysColorIndex[] = {COLOR_3DDKSHADOW, COLOR_3DFACE, COLOR_3DHILIGHT, COLOR_3DLIGHT,
		COLOR_3DSHADOW, COLOR_ACTIVEBORDER, COLOR_ACTIVECAPTION, COLOR_APPWORKSPACE,
		COLOR_BACKGROUND, COLOR_BTNTEXT, COLOR_CAPTIONTEXT,
		// COLOR_GRADIENTACTIVECAPTION, COLOR_GRADIENTINACTIVECAPTION,
		27, 28,
		COLOR_GRAYTEXT, COLOR_HIGHLIGHT, COLOR_HIGHLIGHTTEXT,
		COLOR_INACTIVEBORDER, COLOR_INACTIVECAPTION, COLOR_INACTIVECAPTIONTEXT,
		COLOR_INFOBK, COLOR_INFOTEXT, COLOR_MENU, COLOR_MENUTEXT, COLOR_SCROLLBAR, COLOR_WINDOW,
		COLOR_WINDOWFRAME, COLOR_WINDOWTEXT};

	char* varNameIndex[] = {"3dDkShadow", "3dFace", "3dHilight", "3dLight",
		"3dShadow", "ActiveBorder", "ActiveCaption", "AppWorkspace",
		"Background", "BtnText", "CaptionText",
		"GradientActiveCaption", "GradientInactiveCaption",
		"GrayText", "Hilight", "HilightText",
		"InactiveBorder", "InactiveCaption", "InactiveCaptionText",
		"InfoBk", "InfoText", "Menu", "MenuText", "Scrollbar", "Window",
		"Windowframe", "WindowText"};

	for ( i=0; i<(sizeof(sysColorIndex)/sizeof(int)); i++ )
	{

	color = GetSysColor(sysColorIndex[i]);

	sprintf(clrVal, "%02X%02X%02X", GetRValue(color), GetGValue(color), GetBValue(color));
	
	LSSetVariable(varNameIndex[i], clrVal);
	}

	SystemParametersInfo(SPI_GETMENUDROPALIGNMENT, 0, &sysBool, 0);
	itoa(sysBool ? 1 : 0, clrVal, 10);
	LSSetVariable("MenuDropAlignment", clrVal);

	// Font names //////////////////////////////
	SystemParametersInfo(SPI_GETICONTITLELOGFONT, sizeof(LOGFONT), &fontInfo, 0);
	char icontitlefont[64] = {0};
	sprintf(icontitlefont, "\"%s\"", fontInfo.lfFaceName);
	LSSetVariable("IconTitleFont", icontitlefont);
	
	ncMetrics.cbSize = sizeof(NONCLIENTMETRICS);
	SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncMetrics, 0);

	char captionfont[64] = {0};
	char smcaptionfont[64] = {0};
	char menufont[64] = {0};
	char statusfont[64] = {0};
	char messagefont[64] = {0};
	
	sprintf(captionfont, "\"%s\"", ncMetrics.lfCaptionFont.lfFaceName);
	sprintf(smcaptionfont, "\"%s\"", ncMetrics.lfSmCaptionFont.lfFaceName);
	sprintf(menufont, "\"%s\"", ncMetrics.lfMenuFont.lfFaceName);
	sprintf(statusfont, "\"%s\"", ncMetrics.lfStatusFont.lfFaceName);
	sprintf(messagefont, "\"%s\"", ncMetrics.lfMessageFont.lfFaceName);
	
	LSSetVariable("CaptionFont", captionfont);
	LSSetVariable("SmCaptionFont", smcaptionfont);
	LSSetVariable("MenuFont", menufont);
	LSSetVariable("StatusFont", statusfont);
	LSSetVariable("MessageFont", messagefont);


	// Font Heights //////////////////////////////

	int PointSize = 100;
	
	int icontitlefontheightint = 0;
	int captionfontheightint = 0;
	int smcaptionfontheightint = 0;
	int menufontheightint = 0;
	int statusfontheightint = 0;
	int messagefontheightint = 0;
	
	icontitlefontheightint = -MulDiv(PointSize, fontInfo.lfHeight, 72);
	captionfontheightint = -MulDiv(PointSize, ncMetrics.lfCaptionFont.lfHeight, 72);
	smcaptionfontheightint = -MulDiv(PointSize, ncMetrics.lfSmCaptionFont.lfHeight, 72);
	menufontheightint = -MulDiv(PointSize, ncMetrics.lfMenuFont.lfHeight, 72);
	statusfontheightint = -MulDiv(PointSize, ncMetrics.lfStatusFont.lfHeight, 72);
	messagefontheightint = -MulDiv(PointSize, ncMetrics.lfMessageFont.lfHeight, 72);

	char icontitlefontheight[64] = {0};
	char captionfontheight[64] = {0};
	char smcaptionfontheight[64] = {0};
	char menufontheight[64] = {0};
	char statusfontheight[64] = {0};
	char messagefontheight[64] = {0};
	
	sprintf(icontitlefontheight, "\"%i\"", icontitlefontheightint);
	sprintf(captionfontheight, "\"%i\"", captionfontheightint);
	sprintf(smcaptionfontheight, "\"%i\"", smcaptionfontheightint);
	sprintf(menufontheight, "\"%i\"", menufontheightint);
	sprintf(statusfontheight, "\"%i\"", statusfontheightint);
	sprintf(messagefontheight, "\"%i\"", messagefontheightint);
	
	LSSetVariable("IconTitleFontHeight", icontitlefontheight);
	LSSetVariable("CaptionFontHeight", captionfontheight);
	LSSetVariable("SmCaptionFontHeight", smcaptionfontheight);
	LSSetVariable("MenuFontHeight", menufontheight);
	LSSetVariable("StatusFontHeight", statusfontheight);
	LSSetVariable("MessageFontHeight", messagefontheight);

	
	// Font Bold //////////////////////////////
	SystemParametersInfo(SPI_GETICONTITLELOGFONT, sizeof(LOGFONT), &fontInfo, 0);
	if (fontInfo.lfWeight > 400 )
		LSSetVariable("IconTitleFontBold", "true");
	else
		LSSetVariable("IconTitleFontBold", "false");

	
	SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncMetrics, 0);

	if (ncMetrics.lfCaptionFont.lfWeight > 400 )
		LSSetVariable("CaptionFontBold", "true");
	else
		LSSetVariable("CaptionFontBold", "false");
	
	if (ncMetrics.lfSmCaptionFont.lfWeight > 400 )
		LSSetVariable("SmCaptionFontBold", "true");
	else
		LSSetVariable("SmCaptionFontBold", "false");

	if (ncMetrics.lfMenuFont.lfWeight > 400 )
		LSSetVariable("MenuFontBold", "true");
	else
		LSSetVariable("MenuFontBold", "false");

	if (ncMetrics.lfStatusFont.lfWeight > 400 )
		LSSetVariable("StatusFontBold", "true");
	else
		LSSetVariable("StatusFontBold", "false");

	if (ncMetrics.lfMessageFont.lfWeight > 400 )
		LSSetVariable("MessageFontBold", "true");
	else
		LSSetVariable("MessageFontBold", "false");

	
	// Font Italic //////////////////////////////
	SystemParametersInfo(SPI_GETICONTITLELOGFONT, sizeof(LOGFONT), &fontInfo, 0);
	if (fontInfo.lfItalic == TRUE )
		LSSetVariable("IconTitleFontItalic", "true");
	else
		LSSetVariable("IconTitleFontItalic", "false");

	
	SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncMetrics, 0);

	if (ncMetrics.lfCaptionFont.lfItalic == TRUE )
		LSSetVariable("CaptionFontItalic", "true");
	else
		LSSetVariable("CaptionFontItalic", "false");
	
	if (ncMetrics.lfSmCaptionFont.lfItalic == TRUE )
		LSSetVariable("SmCaptionFontItalic", "true");
	else
		LSSetVariable("SmCaptionFontItalic", "false");

	if (ncMetrics.lfMenuFont.lfItalic == TRUE )
		LSSetVariable("MenuFontItalic", "true");
	else
		LSSetVariable("MenuFontItalic", "false");

	if (ncMetrics.lfStatusFont.lfItalic == TRUE )
		LSSetVariable("StatusFontItalic", "true");
	else
		LSSetVariable("StatusFontItalic", "false");

	if (ncMetrics.lfMessageFont.lfItalic == TRUE )
		LSSetVariable("MessageFontItalic", "true");
	else
		LSSetVariable("MessageFontItalic", "false");

	return code;
}

void quitModule(HINSTANCE dllInst)
{
}
